/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.gebietsbaum;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.gebietsbaum.boundary.AbstractGebietSearchParameters;
import de.ivu.elect.business.gebietsbaum.boundary.GebietChangeEvent;
import de.ivu.elect.business.gebietsbaum.boundary.GebietConversationStore;
import de.ivu.elect.business.gebietsbaum.boundary.GebietExtendedDAO;
import de.ivu.elect.business.gebietsbaum.boundary.GebietSearch;
import de.ivu.elect.business.gebietsbaum.boundary.GebietSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.gebietsbaum.entity.Gebiet;
import de.ivu.elect.business.gebietsbaum.entity.GebietMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractGebietSearchView.COMPONENT_NAME)
@View(viewId = AbstractGebietSearchView.VIEW_ID, useCase = UseCasePermission.GEBIET_SEARCH)
public abstract class AbstractGebietSearchView extends AbstractElectSearchView<Gebiet> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gebietSearchView";
  
  public static final String VIEW_ID = "/gebietsbaum/gebiet-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractGebietSearchView requestHandler;

  @Inject
  private transient GebietExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(GebietConversationStore.class)
  protected transient GebietConversationStore conversationStore;

  @Inject
  protected transient GebietSearch search;

  @Inject
  @ConversationGroup(AbstractGebietSearchParameters.class)
  protected transient GebietSearchParameters searchParameters;

  @Inject
  protected transient GebietMeta entityMeta;

  public AbstractGebietSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Gebiet getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Gebiet entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public GebietSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Gebiet> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Gebiet> create();
  }

  @Override
  public List<Gebiet> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Gebiet> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onGebietChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) GebietChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractGebietSearchView {

    @View
    @Inject
    private transient Instance<AbstractGebietSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractGebietSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
